'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var lezer = require('lezer');
var language = require('@codemirror/language');
var highlight = require('@codemirror/highlight');
var autocomplete = require('@codemirror/autocomplete');
var view = require('@codemirror/view');

// This file was generated by lezer-generator. You probably shouldn't edit it.
const parser = lezer.Parser.deserialize({
  version: 13,
  states: "#SQYQPOOOvQPO'#CjO!WQPO'#CgOOQO'#Cn'#CnQYQPOOOOQO'#Cc'#CcOYQPO,58{OYQPO,58{OYQPO,58{OYQPO,59ROOQO-E6h-E6hOOQO1G.g1G.gO!zQPO1G.gO#RQPO1G.gO#YQPO1G.mOOQO7+$X7+$X",
  stateData: "#a~OaOSPOS~ORROSRO[QO~OUUOWVOXWOcTOdTO~OR^XS^X[^X_^X~PeO]XO~OUUOcTOdTORTiSTiXTi[Ti_TiYTi~OWTi~P!]OWVO~P!]OY_O~PeO",
  goto: "!YcPPPPPdPlPPPdPPrPPPx]ROSUVWXXUP[]^QSORYSSPOSQZUQ[VQ]WR^X",
  nodeNames: "⚠ LineComment Program Identifier String BinaryExpression CompareOp CompareOp LogicOp LogicOp ) Function Keyword (",
  maxTerm: 20,
  skippedNodes: [0,1],
  repeatNodeCount: 1,
  tokenData: "(O~RdXY!aYZ!a]^!apq!aqr!rrs!}xy#lyz#q}!O#v!Q![#v!]!^$d!^!_$o!_!`!r!`!a$w!c!d%P!d!q#v!q!r&v!r!}#v#R#S#v#T#o#v~!fSa~XY!aYZ!a]^!apq!a~!uP!_!`!x~!}OU~~#QTOr!}rs#as#O!}#O#P#f#P~!}~#fOS~~#iPO~!}~#qO]~~#vOY~~#{UR~}!O#v!Q![#v![!]$_!c!}#v#R#S#v#T#o#v~$dO[~~$iQP~OY$dZ~$d~$tPc~!_!`!x~$|Pd~!_!`!x~%UWR~}!O#v!Q![#v![!]$_!c!p#v!p!q%n!q!}#v#R#S#v#T#o#v~%sWR~}!O#v!Q![#v![!]$_!c!f#v!f!g&]!g!}#v#R#S#v#T#o#v~&dUR~W~}!O#v!Q![#v![!]$_!c!}#v#R#S#v#T#o#v~&{WR~}!O#v!Q![#v![!]$_!c!t#v!t!u'e!u!}#v#R#S#v#T#o#v~'lUR~X~}!O#v!Q![#v![!]$_!c!}#v#R#S#v#T#o#v",
  tokenizers: [0],
  topRules: {"Program":[0,2]},
  tokenPrec: 0
});

const papershiveLanguage = language.LezerLanguage.define({
    parser: parser.configure({
        props: [
            /* foldNodeProp.add({
              Application: foldInside
            }), */
            highlight.styleTags({
                Identifier: highlight.tags.variableName,
                String: highlight.tags.string,
                LineComment: highlight.tags.lineComment,
                "( )": highlight.tags.paren,
                LogicOp: highlight.tags.logicOperator,
                CompareOp: highlight.tags.compareOperator,
                Function: highlight.tags.function,
                "au: a: t: ta: y: c:": highlight.tags.keyword
            })
        ]
    }),
    languageData: {
        commentTokens: { line: ";" }
    }
});
const papershiveCompletion = papershiveLanguage.data.of({
    autocomplete: autocomplete.completeFromList([
        {
            label: "au:",
            type: "function",
            detail: "Authors",
            apply: (view$1, completion, from, to) => {
                console.log(view.EditorView, completion, from, to);
            }
        },
        { label: "a:", type: "function", detail: "Abstracts", apply: 'a:("")' },
        { label: "t:", type: "function", detail: "Titless" },
        { label: "ta:", type: "function", detail: "Titles and Abstracts" },
        { label: "y:", type: "function", detail: "Year" },
        { label: "c:", type: "function", detail: "Citations" },
        {
            label: "AND",
            type: "logicOperator"
        },
        { label: "OR", type: "logicOperator" }
    ])
});
function papershive() {
    return new language.LanguageSupport(papershiveLanguage, [papershiveCompletion]);
}

exports.papershive = papershive;
exports.papershiveCompletion = papershiveCompletion;
exports.papershiveLanguage = papershiveLanguage;
